package meerkat;

/**
 * Provides the validation option for objects
 * @param <T>
 */
public interface MessageValidator<T>
{
    /**
     * Throws ValidationError when no part of the object is valid else return the valid part
     * @param object object which will be checked
     * @return T object
     */
    T validate(T object) throws ValidationError;

    class ValidationError extends Exception {
        public ValidationError(String message) {
            super(message);
        }
    }
}
